;*************************************************************************
; FILE ..........: ESC400Rev.rev
; AUTHOR ........: Patracky Aleksey 
; DESCRIPTION ...:      
; NOTES .........:
; COPYRIGHT .....: Patracky Aleksey , 2004
; HISTORY .......: DATE		COMMENT
;                  ---------------------------------------------------
;*************************************************************************
#define	Pic12F675	
;		PROCESSOR	PIC12CE519
;		PROCESSOR	PIC12C509
;		INCLUDE		<P12C509.inc>
;        __config  _MCLRE_OFF & _CP_OFF & _WDT_ON & _IntRC_OSC

		PROCESSOR	PIC12F675
		INCLUDE		<P12F675.inc>
        __config  _MCLRE_OFF & _CP_OFF & _WDT_ON & _INTRC_OSC_NOCLKOUT

		radix		dec
;    GPIO,     ( TRIS)
;StartBtnBit	EQU	1               ;   "Quick Start"
;StopBit         EQU       1               ; Turns on brake
;RunBit          EQU	2               ;   
ForwardBitPulse	EQU     1          	;     
ForwardBitOn	EQU     2          	;    
ReverceBitPulse	EQU		4           ;     
ReverceBitOn	EQU		5           ;    
ServoBit        EQU	0               ;   
BattOkBit       EQU	3               ;   

;TrisBits        EQU       H'FF' & ~((1 << StopBit) | (1 << RunBit))
TrisBits        EQU       H'FF' & ~((1 << ForwardBitPulse) | (1 << ReverceBitPulse) | (1 << ForwardBitOn) | (1 << ReverceBitOn))


; Bits to be set with the OPTION instruction
;  No wake up
;  Weak pull-up enabled
;  Timer 0 source internal
;  Which edge is don't care
;  Prescaler to watchdog, set to give 16*17 ms timeout
;
OptionBits	EQU	B'10011100'

; ==========================================================================
;   
;
PWM_Period	EQU	47		;    7 
PWM_Start	EQU	4		; Lowest cycle count
InvalidPulseBit	EQU	7		; 0x80
BrakeEnableBit	EQU	6		; 0x40
ArmPulsesReqd	EQU	5		; consecutive in-range pulses

;AAP added
ClrAllRunPulseBit	EQU	B'11001001'		; gpio = GPIO and  ClrAllRunPulseBit
ClrAllPulseBit	EQU	B'11101101'		; gpio = GPIO and  ClrAllpulseBit
DirBit			EQU	0				;        RunDirection -  ,  .
ReverceEnableBit		EQU	6				; 0x40
ForwardRunCmnd	EQU	B'00000110'				; 
ReverceRunCmnd	EQU	B'00110000'				; 
BrackeCmnd		EQU	B'00000000'				; 

; ==========================================================================
;  
;
BattLow         EQU	0
PriorServoBit   EQU	1
;
; 
;

        IFNDEF __12F675
;StartReg	EQU	H'20'           
		ELSE
;StartReg	EQU	H'8'           
        ENDIF

		
StartReg	EQU	H'20'           

Flags		EQU	StartReg+1			;    
PwmCount	EQU	Flags + 1		;  
						;   -
PwmWidth	EQU	PwmCount + 1		;  -
ServoCount	EQU	PwmWidth + 1		;  
						;  
						; ( )
Command		EQU	ServoCount + 1		;  , 
						;  
						;  
ArmPulseCount	EQU	Command + 1		;  ""
						; ,  
						;  
RunDirection	EQU	ArmPulseCount + 1		;AAP added :   


;ServoCountHi	EQU	ArmPulseCount + 1	;  
						;  
						; ( )
;Tmp		EQU	ServoCountHi + 1	;  


; =========================================================================
;       "NOP"
;
NO_OP		MACRO	count
NO_OP_COUNT	SET	count
		WHILE	NO_OP_COUNT
		nop
NO_OP_COUNT	SET	NO_OP_COUNT - 1
		ENDW
		ENDM

; =========================================================================
;        .
;  , W   
;

;          2
DoRunBit	MACRO				; 12 
		movf	PwmWidth, W		;   
		movwf	PwmCount		;   		
;		movlw	ClrAllRunBit	;     
;		andwf	GPIO,F			;        -  
;		DoServoCount			; 2 
		movf	RunDirection, W	;  
		movwf	GPIO			;       -      (    )
		movlw	ClrAllPulseBit	;       W

		ENDM


;		btfss	RunDirection,DirBit	;   
;		bsf		GPIO, ForwardBit	;  
;		btfsc	RunDirection,DirBit ;   
;		bsf		GPIO, ReverceBit	;                                       

;DoRunBit	MACRO				; 5 
;		movf	PwmWidth, W
;		skpz
;		bsf	GPIO, RunBit
;		skpnz
;		bcf	GPIO, RunBit
;		ENDM

; =========================================================================
;      
;
DoServoCount	MACRO				; 2 
		btfsc	GPIO, ServoBit
		incf	ServoCount, F
		ENDM


; =========================================================================
; =========================================================================
; ,  .

Coldstart:	ORG	0


;12c509		movwf	OSCCAL		;   
;12c509		bcf	STATUS, PA0		;  ,    
	
		bsf		STATUS,	RP0	; 1
		call	3FFh		;  
		movwf	OSCCAL	
		bcf		STATUS,	RP0	; 0

;
;    .   
;  TMR0  WDT,    
;
;12c509		clrwdt
;12c509		clrf	TMR0
;12c509		movlw	OptionBits | 7
;12c509		option
;12c509		clrwdt
;12c509		movlw	OptionBits
;12c509		option
;12c509		clrwdt

		bcf		STATUS,	RP0
		clrwdt
		clrf	TMR0
		bsf		STATUS,RP0
		
		movlw	b'00101111'
		movwf	OPTION_REG
		clrwdt
		
		movlw	b'00101111'
		movwf	OPTION_REG
		bcf		STATUS,	RP0

		
;12c509		clrf	GPIO			;   /
;12c509		movlw	TrisBits
;12c509		tris	GPIO			;   -  0
		bcf		STATUS,RP0
		clrf	GPIO			;   /

		movlw	0x07
		movwf	CMCON

		bsf		STATUS,RP0
		movlw	1
		movwf	WPU
		clrf	ANSEL
		movlw	TrisBits
		movwf	TRISIO
		bcf		STATUS,RP0
		
; =========================================================================
;(!) . 
;  .
;      
;       .
;    ,     .
;        .
;      .
		goto	aap		



; =========================================================================
; (!) .        ,  
;    .   ,   
; .
;
Rearm:		clrwdt
;		btfss	GPIO, BattOkBit
;		goto	Rearm
;
;      
; (      )
;
RaLoop1:
;		btfss	GPIO, BattOkBit
;		goto	Rearm
		btfss	GPIO, ServoBit
		goto	RaLoop1
RaLoop2:
;		btfss	GPIO, BattOkBit
;		goto	Rearm
		btfsc	GPIO, ServoBit
		goto	RaLoop2
		clrf	ServoCount
		clrwdt
		movlw	ArmPulsesReqd
		movwf	ArmPulseCount

;
; ,      
;
RaLoop3:
;		btfss	GPIO, BattOkBit
;		goto	Rearm
		btfss	GPIO, ServoBit
		goto	RaLoop3

		clrf	ServoCount

RaLoop4:	incf	ServoCount, F
;		btfss	GPIO, BattOkBit
;		goto	Rearm
		NO_OP	1
		btfsc	GPIO, ServoBit
		goto	RaLoop4			;     7 
		clrwdt
		movf	ServoCount, W
		call	ServoLookup
;12c509		bcf		STATUS, PA0		;  
		bcf		STATUS, RP0		;  
						;  
;     ,  
;    ( )
;AAP XZ		andlw	1 << BrakeEnableBit
		andlw   0xff
		skpz
		goto	RaLoop1

		decfsz	ArmPulseCount,F		;   
						;  ""
						;  ?
		goto	RaLoop3

;    !
aap:
		clrf	PwmWidth		;  
		clrf	PwmCount		;  
		clrf	Flags			;    
		clrf	RunDirection
		movlw	ClrAllRunPulseBit	;       W

PreMainPwmLoop:
		NO_OP	1
; ===========================================================
;    -
;
MainPwmLoop:
		DoServoCount			; 4th Precycle
		movlw	ClrAllPulseBit	;       W

PwmEntry1:
		call	DoPwmPulse
		DoServoCount			;
		DoRunBit
		DoServoCount			; 1st Precycle
;aap		movwf	PwmCount		; From DoRunBIt
		nop						;AAP
		btfsc	GPIO, ServoBit
		goto	ServoIsHigh
		btfsc	Flags, PriorServoBit
		goto	EndOfPulse
		DoServoCount			; 2nd Precycle
MainPwmEntry:
		nop 
		btfsc	Flags, BattLow		; Sneak this in here
		goto	BattLoShutdown
		goto	MainPwmLoop
ServoIsHigh:
		bsf	Flags, PriorServoBit
		nop
		DoServoCount			; 3rd Precycle, different path
		nop
		btfsc	Flags, BattLow		; Sneak this in here
		goto	BattLoShutdown		; If batt was ever low, quit now
		goto	MainPwmLoop

; ========================`====================================================
;   :
;   DoPwmPulse
;    2*nop
;   DoRunBit   
;    17*nop
;   DoPwmPulse    ..
;
;      
;  NOP   
;
EndOfPulse:
		bcf	Flags, PriorServoBit
		clrwdt
		NO_OP	6
		movlw	ClrAllPulseBit	;                                                                                       W
 		call	DoPwmPulse
		NO_OP	2
;
		DoRunBit
		nop						;aap movwf	PwmCount
		movf	ServoCount, W
		call	ServoLookup		; 7 clocks
		movwf	Command
		nop						;aap movwf	PwmCount
		clrf	ServoCount
;12c509		bcf	STATUS, PA0
		bcf	PCLATH, 1

		NO_OP	3
		movlw	ClrAllPulseBit	;       W
		call	DoPwmPulse
		NO_OP	2
;
		DoRunBit			; (!)  
							;  
		btfsc	Command, InvalidPulseBit
		goto	BadCommand		;   -   
 		movf	Command,W
		skpnz
		goto 	NoPulse		;	 -  
		andlw	H'3F'			;    
		movwf	PwmWidth

		btfss	Command, ReverceEnableBit
		goto	ForwardCommand
		goto	ReverceCommand
;		
;		NO_OP	3
;		movlw	ClrAllRunBit	;       W
;		call	DoPwmPulse
;		bsf	GPIO, StopBit		;  
;		NO_OP	1
;		DoRunBit
;		NO_OP	7
;		goto	MainPwmEntry
BadCommand:
		NO_OP	2				; 
		movlw	ClrAllRunPulseBit	;       W
		goto	MainPwmEntry

NoPulse:
		NO_OP	7				; 
		clrf	RunDirection
		movlw	ClrAllRunPulseBit	;       W
		goto	PwmEntry1
ForwardCommand:
		nop
		movlw	ForwardRunCmnd	
		movwf	RunDirection
		movlw	ClrAllPulseBit	;       W
		goto	PwmEntry1
ReverceCommand:
		movlw	ReverceRunCmnd	
		movwf	RunDirection
		movlw	ClrAllPulseBit	;       W
		goto	PwmEntry1
RunningCommand:
		
;		bcf	GPIO, StopBit		;   ( 
						;   )
		goto	PwmEntry1		; (!)    .
						;  , 
						;  


; ==========================================================================
;   -  
;     
;
BattLoShutdown:

;		bcf	GPIO, RunBit
; WARNING - DON'T DIDDLE THE GPIO REGISTER until the RunBit settles.
; You may end up leaving it set!
		movlw	ClrAllRunPulseBit	;       W
		call	DoPwmPulse		; For delay only
;		bsf	GPIO, StopBit		;  
		nop
		goto	Rearm

; ==========================================================================
;     .    W
; (!)   PA0    1.
; PC = (PA0 << 9) | (0 << 8) | W.
; ,   ,    speed400.inc
;
ServoLookup:
;12c509		bsf	STATUS, PA0
		bsf	PCLATH, 1
		movwf	PCL
; ==========================================================================
;   1  -.  ,    
;  .  ,    .    ,
;      PWM_Count .
;
DoPwmPulse:
PWM_LOOP_COUNT	SET	PWM_Period - PWM_Start
		WHILE	PWM_LOOP_COUNT
		nop						; aap
		nop
		DoServoCount			; 2 
		decf	PwmCount,F
		skpnz
		andwf	GPIO,F			; aap        -  
PWM_LOOP_COUNT	SET	PWM_LOOP_COUNT - 1
		ENDW

		retlw	0

;aap		btfss	GPIO, BattOkBit
;aap		bsf	Flags, BattLow
; aap		bcf	GPIO, RunBit

; ==========================================================================
;      .
;  - 0..255,     8  
; ,   7- .
;  :
;   PWM_width | ((invalid width)? 0x80 : 0) | ((Brake width range)? 0x40 : 0)
; PWM_width     0  63,  0 
;  
;
			ORG       H'200'          ; Low part of second page (PA0==1)
			INCLUDE   "esc400rev.inc"  ;


			END

